//+------------------------------------------------------------------+
//|                                                    gold-dust.mq4 |
//|                               Copyright  2011, Yury V. Reshetov |
//|                               http://gold-dust.info              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Yury V. Reshetov"
#property link      "http://gold-dust.info"

//---- input parameters

extern int          z=8;
extern int          k=5;
extern double       sl = 500;
extern int          pass = 1;
extern double       lots = 1.0;
extern int          moneymanagement = 0;
extern double       risk = 0.0;
extern int          mn = 888;
static int          prevtime = 0;


int init() {
   prevtime = Time[0];
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (Time[0] == prevtime) return(0);
   prevtime = Time[0];
   
   if (! IsTradeAllowed()) {
      again();
      return(0);
   }
//----
   int total = OrdersTotal();
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == mn)) {
         return(0);
      } 
   }
   
   
   int ticket = -1;
   int rezult = -1;
   
   RefreshRates();
   
   if (Supervisor() == 0) {
      return(0);
   }
   
   double lt = lots;
   
   if (moneymanagement > 0) {
      lt = getLots();
   }
//////     
   if (Supervisor() > 0) {
   
      ticket = OrderSend(Symbol(), OP_BUY, lt, Ask, 1, Bid - sl * Point, Bid + sl * Point, WindowExpertName(), mn, 0, Blue); 
      if (ticket < 0) {
         again();      
      }
   } else {
            
      ticket = OrderSend(Symbol(), OP_SELL, lt, Bid, 1, Ask + sl * Point, Ask - sl * Point, WindowExpertName(), mn, 0, Red); 
      if (ticket < 0) {
         again();
      }
   }
   
//-- Exit --
   return(0);
}
//+--------------------------- Supervisor ----------------------------------+


int Supervisor() {
   if (iCustom(NULL, 0, "TD",z,k,2,1)!=0) {
      return (1);
   }
   if (iCustom(NULL, 0, "TD",z,k,3,1)!=0) {
      return (-1);
   }
   
   return (0);
}



int Class1()   {
   
   if (Close[1]>Open[1]) {
      return (1);
   }
   return (-1);
}






void again() {
   prevtime = Time[1];
   Sleep(30000);
}

double getLots() {
   double minlot = MarketInfo(Symbol(), MODE_MINLOT);
   int round = MathAbs(MathLog(minlot) / MathLog(10.0)) + 0.5;
   double lot = minlot;
//---- select lot size
   lot = NormalizeDouble(AccountFreeMargin() * risk / 100000.0, round);
   if (AccountFreeMargin() < lot * MarketInfo(Symbol(), MODE_MARGINREQUIRED)) {
      lot = NormalizeDouble(AccountFreeMargin() / MarketInfo(Symbol(), MODE_MARGINREQUIRED), round);
   }
   if(lot < minlot) lot = minlot;
   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   if(lot > maxlot) lot = maxlot;
//---- return lot size
   return(lot);
}

